#ifndef CPP_UNIT_CONFIGURATIONFILERETRIEVER_H
#define CPP_UNIT_CONFIGURATIONFILERETRIEVER_H


#include "DeviceConfigurator.h"


class ConfigurationFileRetriever
{
	friend class ConfigurationFileRetrieverTestCase;

public:

	ConfigurationFileRetriever();

	ConfigurationFileRetriever( const string informationFilePath,
								const string historyFilePath );

	~ConfigurationFileRetriever();

	DeviceConfiguratorStatus GetConfigurationFilePath( DeviceInfo deviceInfo,
													 string& configurationFilePath );

private:

	DeviceConfiguratorStatus checkForNewerConfigurationFile( const string& configurationFileReference,
															string& newerConfigurationFileReference );
	
	DeviceConfiguratorStatus getConfigurationFileReference( DeviceInfo deviceInfo,
													 string& configurationFileReference );
	
	DeviceConfiguratorStatus createConfigurationFilePathFromReference( const string& configurationFileReference,
																		string& configurationFilePath );

	DeviceConfiguratorStatus getDescriptorFromLine( const char* line, string& descriptor );

	string getReferenceFromLine( const char* line );


	DeviceInfo m_DeviceInfo;

	string m_strInformationFilePath;

	string m_strHistoryFilePath;
};
	
#endif