#include "StdAfx.h"
#include "ConfiguratorService.h"
#include "ConfigurationFileRetriever.h"
#include "ConfigurationFileProcessor.h"


ConfiguratorService::ConfiguratorService()
{	
}

DeviceConfiguratorStatus ConfiguratorService::GetConfigurationCommands( 
								DeviceInfo deviceInfo, LicenseInfo licenseInfo,
								ConfigurationCommand*& commands, int& commandsCount )
{
	DeviceConfiguratorStatus status = DEVICE_CONFIGURATOR_FAILED;
	commands = NULL;
	commandsCount = 0;

	string configurationFilePath = "";
	ConfigurationFileRetriever configurationFileRetriever;
	status = configurationFileRetriever.GetConfigurationFilePath( deviceInfo, 
														configurationFilePath );
	
	if ( status != DEVICE_CONFIGURATOR_OK )
	{
		return status;
	}

	status = processConfigurationFile( configurationFilePath, 
										commands, commandsCount );

	return status;
}

DeviceConfiguratorStatus ConfiguratorService::processConfigurationFile( 
								const string configurationFilePath,
								ConfigurationCommand*& commands, int& commandsCount )
{
	DeviceConfiguratorStatus status = DEVICE_CONFIGURATOR_FAILED;
	ConfigurationFileProcessor configurationFileProcessor;
	configurationFileProcessor.SetConfigurationFilePath( configurationFilePath );

	status = configurationFileProcessor.ProcessConfigurationFile( 
													commands, commandsCount );

	return status;
}