#ifndef CPP_UNIT_CLIENTMANAGERTESTCASE_H
#define CPP_UNIT_CLIENTMANAGERTESTCASE_H

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

// tested object
#include "ClientManager.h"

/*
This is a tester class for ClientManager.
*/
class ClientManagerTestCase : public CppUnit::TestCase
{
	CU_TEST_SUITE( ClientManagerTestCase );
  
	CU_TEST( testCheckLicense );
	CU_TEST( testCheckLicense_fail_invalidLicense );
	CU_TEST( testCheckLicense_fail_noLicenseFile );

	CU_TEST( testSplitLine );
	CU_TEST( testSplitLine_emptyElements );

	CU_TEST( testMatchLicense );
	CU_TEST( testMatchLicense_fail_invalidLicense );

	CU_TEST_SUITE_END();

public:

	void setUp();
	void tearDown();

protected:

	void testCheckLicense();
	void testCheckLicense_fail_invalidLicense();
	void testCheckLicense_fail_noLicenseFile();

	void testSplitLine();
	void testSplitLine_emptyElements();

	void testMatchLicense();
	void testMatchLicense_fail_invalidLicense();

private:

	DeviceInfo m_DeviceInfo;
	LicenseInfo m_LicenseInfo;
};


#endif