#ifndef CPP_UNIT_CONFIGURATIONFILEPROCESSORTESTCASE_H
#define CPP_UNIT_CONFIGURATIONFILEPROCESSORTESTCASE_H

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

// tested object
#include "ConfigurationFileProcessor.h"

/*
This is a tester class for ConfigurationFileProcessor.
*/
class ConfigurationFileProcessorTestCase : public CppUnit::TestCase
{
	CU_TEST_SUITE( ConfigurationFileProcessorTestCase );

	CU_TEST( testGetConfigurationFilePath );

	CU_TEST( testSetConfigurationFilePath );

	CU_TEST( testProcessConfigurationFile );
	CU_TEST( testProcessConfigurationFile_fail_noFile );

	CU_TEST_SUITE_END();

public:

	void setUp();
	void tearDown();

protected:

	void testGetConfigurationFilePath();

	void testSetConfigurationFilePath();
	
	void testProcessConfigurationFile();
	void testProcessConfigurationFile_fail_noFile();

private:

	string m_strConfigurationFilePath;
};


#endif