#ifndef CPP_UNIT_CONFIGURATIONFILERETRIEVERTESTCASE_H
#define CPP_UNIT_CONFIGURATIONFILERETRIEVERTESTCASE_H

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

// tested object
#include "ConfigurationFileRetriever.h"

/*
This is a tester class for ClientManager.
*/
class ConfigurationFileRetrieverTestCase : public CppUnit::TestCase
{
	CU_TEST_SUITE( ConfigurationFileRetrieverTestCase );

	CU_TEST( testGetConfigurationFilePath );
	CU_TEST( testGetConfigurationFilePath_fail_noFileReference );
	CU_TEST( testGetConfigurationFilePath_fail_noInformationFile );

	CU_TEST( testCheckForNewerConfigurationFile );
	CU_TEST( testCheckForNewerConfigurationFile_noHistoryFile );

	CU_TEST( testGetConfigurationFileReference );
	CU_TEST( testGetConfigurationFileReference_fail_notExist );

	CU_TEST( testCreateConfigurationFilePathFromReference );
	CU_TEST( testCreateConfigurationFilePathFromReference_fail_invalidReference );

	CU_TEST( testGetDescriptorFromLine );
	CU_TEST( testGetDescriptorFromLine_fail_invalidLine );

	CU_TEST( testGetReferenceFromLine );
	CU_TEST( testGetReferenceFromLine_fail_invalidLine );

	CU_TEST_SUITE_END();

public:

	void setUp();
	void tearDown();

protected:

	void testGetConfigurationFilePath();
	void testGetConfigurationFilePath_fail_noFileReference();
	void testGetConfigurationFilePath_fail_noInformationFile();

	void testCheckForNewerConfigurationFile();
	void testCheckForNewerConfigurationFile_noHistoryFile();
	
	void testGetConfigurationFileReference();
	void testGetConfigurationFileReference_fail_notExist();
	
	void testCreateConfigurationFilePathFromReference();
	void testCreateConfigurationFilePathFromReference_fail_invalidReference();
	
	void testGetDescriptorFromLine();
	void testGetDescriptorFromLine_fail_invalidLine();
	
	void testGetReferenceFromLine();
	void testGetReferenceFromLine_fail_invalidLine();

private:

	DeviceInfo m_DeviceInfo;
};


#endif