#ifndef CPP_UNIT_CONFIGURATORSERVICETESTCASE_H
#define CPP_UNIT_CONFIGURATORSERVICETESTCASE_H

#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>

// tested object
#include "ConfiguratorService.h"

/*
This is a tester class for ConfiguratorService.
*/
class ConfiguratorServiceTestCase : public CppUnit::TestCase
{
	CU_TEST_SUITE( ConfiguratorServiceTestCase );

	CU_TEST( testGetConfigurationCommands );
	CU_TEST( testGetConfigurationCommands_fail_noReference );
	CU_TEST( testGetConfigurationCommands_fail_noFile );

	CU_TEST( testProcessConfigurationFile );
	CU_TEST( testProcessConfigurationFile_fail_noFile );

	CU_TEST_SUITE_END();

public:

	void setUp();
	void tearDown();

protected:

	void testGetConfigurationCommands();
	void testGetConfigurationCommands_fail_noReference();
	void testGetConfigurationCommands_fail_noFile();
	
	void testProcessConfigurationFile();
	void testProcessConfigurationFile_fail_noFile();

private:

	DeviceInfo m_DeviceInfo;
	LicenseInfo m_LicenseInfo;
};


#endif